#ifndef VIEWS_PEOPLE_H
#define VIEWS_PEOPLE_H

#include "../GUI.h"

#include <list>

#include <Lum/Model/Table.h>

#include <Lum/Panel.h>
#include <Lum/Table.h>

namespace Views {

  class People : public ::Base::View
  {
  private:
    Lum::Model::ActionRef    viewAction;
    Lum::Model::ActionRef    addAction;
    Lum::Model::ActionRef    deleteAction;
    Lum::Model::ListTableRef model;
    Lum::Table               *table;
    Lum::Panel               *top;

  private:
    void FillList();

  public:
    People();
    ~People();

    bool VisitChildren(Lum::Visitor &visitor, bool onlyVisible);

    void CalcSize();
    void Layout();

    void Resync(Lum::Base::Model* model, const Lum::Base::ResyncMsg& msg);

    void Load(DataPtr data);
    void Vanish();
  };
}

#endif
